/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomXMLHttpRequest_H__
#define __GdomXMLHttpRequest_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomEvent.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomXMLHttpRequest GdomXMLHttpRequest;
typedef struct _GdomXMLHttpRequestClass GdomXMLHttpRequestClass;


#define GDOM_TYPE_XML_HTTP_REQUEST            (gdom_xml_http_request_get_type())
#define GDOM_XML_HTTP_REQUEST(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_XML_HTTP_REQUEST, GdomXMLHttpRequest))
#define GDOM_XML_HTTP_REQUEST_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_XML_HTTP_REQUEST, GdomXMLHttpRequest)Class)
#define GDOM_IS_XML_HTTP_REQUEST(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_XML_HTTP_REQUEST))
#define GDOM_IS_XML_HTTP_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_XML_HTTP_REQUEST))
#define GDOM_XML_HTTP_REQUEST_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_XML_HTTP_REQUEST, GdomXMLHttpRequestClass))

typedef struct _GdomXMLHttpRequestPrivate GdomXMLHttpRequestPrivate;

struct _GdomXMLHttpRequest {
    GdomDOMObject parent_instance;
    GdomXMLHttpRequestPrivate *priv;
};

struct _GdomXMLHttpRequestClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_xml_http_request_get_type (void);

WEBKIT_API void
gdom_xml_http_request_open (GdomXMLHttpRequest *thiz, gchar * method, gchar * url, gboolean async, gchar * user, gchar * password);

WEBKIT_API void
gdom_xml_http_request_set_request_header (GdomXMLHttpRequest *thiz, gchar * header, gchar * value);

WEBKIT_API void
gdom_xml_http_request_send (GdomXMLHttpRequest *thiz, gchar * data);

WEBKIT_API void
gdom_xml_http_request_abort (GdomXMLHttpRequest *thiz);

WEBKIT_API gchar *
gdom_xml_http_request_get_all_response_headers (GdomXMLHttpRequest *thiz);

WEBKIT_API gchar *
gdom_xml_http_request_get_response_header (GdomXMLHttpRequest *thiz, gchar * header);

WEBKIT_API void
gdom_xml_http_request_override_mime_type (GdomXMLHttpRequest *thiz, gchar * override);


/* XXX TODO: custom function gdom_xml_http_request_add_event_listener */


/* XXX TODO: custom function gdom_xml_http_request_remove_event_listener */

WEBKIT_API gboolean
gdom_xml_http_request_dispatch_event (GdomXMLHttpRequest *thiz, GdomEvent * evt);

G_END_DECLS

#endif /* __GdomXMLHttpRequest_H__ */
